package com.gyee.alarm.model.vo;

public enum DeviceTypeValue {

    BT("booststation", "升压站报警"),
    IN("inverter", "逆变器报警"),
    WP("station", "场站报警"),
    WT("windturbine", "风机报警");

    private String code;
    private String name;

    DeviceTypeValue(String code) {
        this.code = code;
    }

    DeviceTypeValue(String code, String name) {
        this.code = code;
        this.name = name;
    }

    public String getCode() {
        return code;
    }

    public void setCode(String code) {
        this.code = code;
    }

    public String getName() {
        return name;
    }

    public void setName(String name) {
        this.name = name;
    }

    /**
     * 根据code获取message
     *
     * @param code
     * @return
     */
    public static String getNmaeByCode(String code) {
        for (DeviceTypeValue ele : values()) {
            if (ele.getCode().equals(code)) {
                return ele.getName();
            }
        }
        return null;
    }


}
