package com.gyee.alarm.model.auto;

import com.baomidou.mybatisplus.annotation.IdType;
import com.baomidou.mybatisplus.annotation.TableId;
import com.baomidou.mybatisplus.extension.activerecord.Model;
import lombok.Data;
import lombok.EqualsAndHashCode;

import java.sql.Timestamp;

/**
 * <p>
 * 设备功能统计
 * </p>
 *
 * @author shilin
 * @since 2023-08-14
 */
@Data
@EqualsAndHashCode(callSuper = true)
public class ProBasicFeatureStat extends Model {

    private static final long serialVersionUID = 1L;

    /**
     * 编号
     */
    @TableId(value = "ID",type = IdType.INPUT)
    private String id;

    /**
     * 设备编号
     */
    private String wtId;

    /**
     * 场站编号
     */
    private String stationId;

    /**
     * 统计时间
     */
    private Timestamp statDate;

    /**
     * 总次数
     */
    private Long total;

    /**
     * 总时间
     */
    private Double totalSeconds;

    /**
     * 平均时长
     */
    private Double avgSeconds;

    /**
     * 最大时长
     */
    private Double maxSeconds;

    /**
     * 最小时长
     */
    private Double minSeconds;

    /**
     * 类型编码
     */
    private String typeCode;

    /**
     * 类型名称
     */
    private String typeName;
    /**
     * 报警编号
     */
    private String alarmid;

    /**
     * 描述
     */
    private String description;


}
