package com.gyee.alarm.service.auto;

import com.baomidou.mybatisplus.core.metadata.IPage;
import com.baomidou.mybatisplus.extension.plugins.pagination.Page;
import com.gyee.alarm.init.CacheContext;
import com.gyee.alarm.model.auto.ProEconAlarmConfiguration;
import com.gyee.alarm.model.auto.ProEconAlarmInfo;
import com.baomidou.mybatisplus.extension.service.IService;
import com.gyee.alarm.model.vo.AlarmSuperTalbeType;
import com.gyee.alarm.model.vo.AlarmTypeValue;
import com.gyee.alarm.model.vo.AlarmVo;
import com.gyee.common.model.StringUtils;
import org.springframework.beans.factory.annotation.Value;

import java.util.*;

/**
 * <p>
 * 报警缓存表 服务类
 * </p>
 *
 * @author shilin
 * @since 2023-06-19
 */
public interface IProEconAlarmInfoService extends IService<ProEconAlarmInfo> {

    /**
     * 查询报警信息接口
     * @param begin 开始时间
     * @param end 结束时间
     * @param alarmType 报警类型
     * @param stationid 场站
     * @param description 描述
     * @param pageNum 页数
     * @param pageSize 每页多少条
     * @return
     */
    public IPage<ProEconAlarmInfo> findAlarmlist(Page page, String modelId, Date begin, Date end , String alarmType, String stationid, String deviceid, String description, String deviceType, String components, String alarmId, Boolean isclose, int pageNum, int pageSize);
}
